varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform mediump vec2 pixelSize;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump vec2 layoutStart;
uniform mediump vec2 layoutEnd;
uniform mediump float texelGridSize;

void main(void) {
	mediump vec2 layoutSize = abs(vec2(layoutEnd.x - layoutStart.x, (layoutEnd.y - layoutStart.y))); 
	mediump vec2 texelSize = abs(srcOriginEnd - srcOriginStart) / layoutSize;

	mediump vec2 tile = texelSize * texelGridSize;
	
	mediump vec2 halftile = tile / 2.0;
	mediump vec2 tex = floor(vTex / tile) * tile + halftile;
	tex = clamp(tex, min(srcOriginStart, srcOriginEnd), max(srcOriginStart, srcOriginEnd));
	lowp vec4 front = texture2D(samplerFront, tex + pixelSize);

	gl_FragColor = texture2D(samplerFront, tex + pixelSize);
}