﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

struct ShaderParams {
	texelGridSize : f32
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%


@fragment
fn main(input : FragmentInput) -> FragmentOutput
{	
	let layoutSize : vec2<f32> = abs(vec2(c3Params.layoutEnd.x - c3Params.layoutStart.x, (c3Params.layoutEnd.y - c3Params.layoutStart.y))); 
	let texelSize : vec2<f32> = abs(c3Params.srcOriginEnd - c3Params.srcOriginStart) / layoutSize;
	let tile : vec2<f32> = texelSize * shaderParams.texelGridSize;

	var halftile : vec2<f32> = tile / 2.0;
	var tex : vec2<f32> = floor(input.fragUV / tile) * tile + halftile;
	tex = c3_clampToSrcOrigin(tex);
	var output : FragmentOutput;
	output.color = textureSampleGrad(textureFront, samplerFront, tex, dpdx(input.fragUV), dpdy(input.fragUV));
	return output;
}